var util = require('./util');
var makeCustomerApi = require('./customer');
var makeDataApi = require('./data');
var loaderMod = require('./loader');
var makeTilesApi = require('./tiles');

module.exports = function makeApi(args) {
  
  var sizeup = {};
  
  var apiKey = args.key;
  if (!apiKey) {
    throw new Error("Argument \"key\" is missing. You need a product key to authenticate. Please see https://www.sizeup.com/developers/documentation for help.");  // TODO: no
  }
  var loader = loaderMod(apiKey);
  
  if (args.serviceUrl) {
    var pattern = /^.*:\/\/.*$/;
    var match = args.serviceUrl.match(pattern);
    if (match) {
      loader.me.currentLocation = args.serviceUrl;
    } else {
      throw new Error("Argument \"serviceUrl\" must match pattern " + pattern.source);
    }
  }
  
  sizeup.util = util;
  sizeup.loader = loader;
  sizeup.customer = makeCustomerApi(sizeup);
  sizeup.data = makeDataApi(sizeup);
  sizeup.granularity = require('./granularity');
  sizeup.attributes = require('./attributes');
  sizeup.tiles = makeTilesApi(sizeup);
  
  return sizeup;
};
