const path = require("path");

const SIZEUP = "6388E63C-3D44-472B-A424-712395B1AD51";
const SAMPLE_CUSTOMER = "12345678-1234-1234-1234-123456789ABC";

function getCenteredStart(doc, line, centerPos=306) {
  let widthBizName = doc.widthOfString(line);
  return centerPos - (widthBizName/2);
}

var mockCustomerGraphics = {

  custAddress: "1243 Main St.",
  custCity: "Tuscon",
  custState: "AZ",
  custZip: "80976",
  custEmail: "customer.email@gmail.com",
  custBizName: "Customer Business Name",
  custLogo: "smlogo.png",

  writeHeader: function(doc, theme) {
     // Draw a rectangle for the header 
    doc.moveTo(25, 30)
    .lineTo(588, 30)
    .lineTo(588, 90)
    .lineTo(25, 90)
    .fill('#007bff');

    doc.font('Helvetica-Bold');
    doc.fontSize(22);
    doc.fillColor('white');
    let widthBizName = doc.widthOfString(this.custBizName);
    let startBizName = (245 - (widthBizName/2));
    doc.text(this.custBizName, startBizName, 50);
    doc.image(path.join(__dirname, this.custLogo), 425, doc.y - 32, { width: 120 } );
  },

  writeFooter: function(doc, theme) {
    let nameLine = "Customer Business Name"
    let addressLine = "1234 Main St, Tuscon, AZ 80976";
    let emailLine = "customer.email@gmail.com";
    doc.text(' ');
    doc.font('Helvetica-Bold');
    doc.fontSize(15);
    doc.fillColor(theme.text.color);
    doc.text(nameLine, getCenteredStart(doc, nameLine), 730);
    doc.fontSize(12);
    doc.fillColor('black');
//    let widthAddress = doc.widthOfString(addressString);
//    let startAddress = 306 - widthAddress/2;
//    doc.text(addressString, startAddress, doc.y);
    doc.text(addressLine, getCenteredStart(doc, addressLine), doc.y);
//    let widthEmail = doc.widthOfString(email);
//    let startEmail = 306 - widthEmail/2;
//   doc.text(email, startEmail, doc.y);
    doc.text(emailLine, getCenteredStart(doc, emailLine), doc.y);
  }
};


function mockGetReportGraphics(customerKey) {
  if (customerKey in customerGraphicsDatabase) {
    return customerGraphicsDatabase[customerKey];
  } else {
    throw Error(`Not found: Customer key ${customerKey}`);
  }
}

module.exports = {
  registry: {
    "6388E63C-3D44-472B-A424-712395B1AD51": {
      custBizName: "Business Intelligence for All",
      custLogo: "SizeUp.png",
      
      writeHeader: function(doc, theme) {
        doc.font('Helvetica-Bold');
        doc.text(' ');
        doc.font(path.join(__dirname, '../fonts/SourceSansPro-Light.otf'));
        doc.fontSize(25);
        doc.fillColor('blue');
        let widthBizName = doc.widthOfString(this.custBizName);
        let startBizName = (245 - (widthBizName/2));
        doc.text(this.custBizName, startBizName, 45);
        doc.image(path.join(__dirname, this.custLogo), 425, doc.y - 32, { width: 120 } );
      },

      writeFooter: function(doc, theme) {
        doc.text(' ');
        doc.image(path.join(__dirname, "gauge-home.png"), 80, 725);
        doc.font(path.join(__dirname, '../fonts/SourceSansPro-Light.otf'));
        doc.fillColor('black');
        doc.fontSize(12);
        doc.text('How is My Business Performing?', 140, 725, { continued: true, width: 100});
        doc.image(path.join(__dirname, "marketing-home.png"), 250, 730);
        doc.text(' ');
        doc.text('Where should I advertise?', 310, 725, { continued: true, width: 100, align : 'left' });
        doc.image(path.join(__dirname, this.custLogo), 420, 730, { width: 120 } );
      }
    },
    "12345678-1234-1234-1234-123456789ABC": mockCustomerGraphics
  }
};
