const util = require("util");
var endpoint = process.argv[2];
if ( ! endpoint) { throw new Error("No endpoint set in argv[2]"); }
sizeup = require(".")({
  key:"6388E63C-3D44-472B-A424-712395B1AD51",
  serviceUrl:endpoint
});

sizeup.data.getIndustryBySeokey({
  seokey:"pizza"
}, console.log, console.error);

sizeup.data.findPlace({
  term:"da",
  stateId:[130073],
  maxResults:10
}).then(
  d => console.log(d.map(p=>p.DisplayName))
).catch(console.error);

sizeup.loader.getData("/data/revenuePerCapita/quantiles", {
  granularity:"ZipCode",
  boundingGeographicLocationId:128533,
  bands:5,
  industryId:8603
}).then(d => {
  d.Quantiles.forEach(q => {
    var m = q.Members[0];
    console.log(
      JSON.stringify(q.Boundary) + " "
      + m.Key.LongName + ": " + m.Value.Min + "-" + m.Value.Max);
  });
}).catch(console.error);

// Example from the docs:

////// Look up industry and place objects //////
Promise.all([
  sizeup.data.getIndustryBySeokey("coffee-shops"),
  sizeup.data.getPlaceBySeokey("california/alameda/oakland-city"),
]).then(([[industry], [place]]) => {
  Promise.all([
    ////// Get citywide data //////
    sizeup.data.getRevenuePerCapita({geographicLocationId: place.City.Id, industryId: industry.Id}),
    ////// Get countywide data //////
    sizeup.data.getRevenuePerCapita({geographicLocationId: place.County.Id, industryId: industry.Id}),
  ]).then(([city_data, county_data]) => {
    console.log(util.format(
      "Revenue per capita of %s businesses in %s: $%s",
      industry.Name, place.City.Name, city_data.Value));
    console.log(util.format(
      "Revenue per capita of %s businesses in %s County: $%s",
      industry.Name, place.County.Name, county_data.Value));
  }).catch(console.error);
}).catch(console.error);
